-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["ROGUE"] = {}
local t,s

lib.classes["ROGUE"][2] = function()
	lib.SetAltPower(SPELL_POWER_COMBO_POINTS,COMBO_POINTS)
	lib.AddSpell("SS",{1752}) -- Sinister Strike
	lib.AddSpell("RS",{84617}) -- Revealing Strike
	lib.AddAura("RS",84617,"debuff","target") -- Revealing Strike
	cfg.gcd = "SS"
	lib.AddSpell("Ambush",{8676}) -- Ambush
	lib.AddSpell("SnD",{5171}) -- Slice and Dice
	lib.AddAura("SnD",5171,"buff","player") -- Slice and Dice
	lib.AddSpell("Eviscerate",{2098}) -- Eviscerate
	--lib.AddSpell("Rupture",{1943}) -- Rupture
	--lib.AddAura("Rupture",1943,"debuff","target") -- Rupture

	--lib.AddAuras("Mangle",{35290,57386,50271,16511,33876,33878,46857},"debuff","target") -- Mangle
	
	--lib.AddAuras("FF",{91565,95466,7386,8647,95467},"debuff","target") -- FF
	
	lib.AddSpell("Preparation",{14185}) -- Preparation
	lib.AddSpell("AR",{13750}) -- Adrenaline Rush
	lib.AddAura("AR",13750,"buff","player") -- Adrenaline Rush
	lib.AddSpell("KS",{51690}) -- Killing Spree
	lib.AddAura("Anticipation",115189,"buff","player") -- Anticipation
	lib.AddSpell("Anticipation",{114015}) -- Anticipation
	lib.AddAura("Deep_Insight",84747,"buff","player") -- Deep Insight
	
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Preparation")
	table.insert(cfg.plistdps,"Ambush")
	table.insert(cfg.plistdps,"Vanish")
	table.insert(cfg.plistdps,"SnD_noSnD")
	table.insert(cfg.plistdps,"AR")
	table.insert(cfg.plistdps,"KS")
	table.insert(cfg.plistdps,"RS_noRS")
	table.insert(cfg.plistdps,"SS")
	table.insert(cfg.plistdps,"Eviscerate")
	table.insert(cfg.plistdps,"end")
	
--[[	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"end")]]

	cfg.case = {
		["KS"] = function()
			if lib.PowerInTime(lib.GetSpellCD("KS"))<lib.PowerMax()-lib.PowerInTime(3) and lib.GetSpellCD("KS")>lib.GetAura({"AR"}) then
				return lib.SimpleCDCheck("KS")
			end
			return nil
		end,
		["AR"] = function()
			if lib.GetSpellCD("KS")>lib.GetSpellCD("AR")+15 and lib.Power()<lib.GetSpellCost("SS") then
				return lib.SimpleCDCheck("AR")
			end
			return nil
		end,
		["Preparation"] = function()
			if lib.GetSpellCD("Vanish")>lib.GetSpellCD("Preparation")+30 then
				return lib.SimpleCDCheck("Preparation")
			end
			return nil
		end,
		["RS_noRS"] = function()
			return lib.SimpleCDCheck("RS",lib.GetAura({"RS"})-7.2)
		end,
		["SnD_noSnD"] = function()
			if cfg.AltPower.now>0 then
				if cfg.AltPower.now==cfg.AltPower.max then
					return lib.SimpleCDCheck("SnD",lib.GetAura({"SnD"})-12)
				else
					return lib.SimpleCDCheck("SnD",lib.GetAura({"SnD"})-2)
				end
			end
			return nil
		end,
		["Eviscerate"] = function()
			if cfg.AltPower.now<cfg.AltPower.max then return nil end
			if lib.GetSpellCD("Eviscerate")>lib.GetAura({"RS"}) then return nil end
			if lib.GetSpellCD("Eviscerate")<lib.GetAura({"Deep_Insight"}) then
				return lib.SimpleCDCheck("Eviscerate")
			end
			
			if (lib.KnownSpell("Anticipation") and lib.GetAuraNum("Anticipation")==5)
			or (not lib.KnownSpell("Anticipation")) then
				return lib.SimpleCDCheck("Eviscerate")
			end
			return nil
		end,
		["Ambush"] = function()
			if lib.HasAuras("Vanish") then
				return lib.SimpleCDCheck("Ambush")
			end
			return nil
		end,
		
		["SS"] = function()
			if lib.GetSpellCD("SS")>lib.GetAura({"RS"}) then return nil end
			if cfg.AltPower.now==cfg.AltPower.max and 
			((lib.KnownSpell("Anticipation") and lib.GetAuraNum("Anticipation")==5)  
			or (not lib.KnownSpell("Anticipation"))) then
				return nil
			end
			return lib.SimpleCDCheck("SS")
		end,
		["Rupture_noRupture"] = function()
			if cfg.AltPower.now==cfg.AltPower.max then
				return lib.SimpleCDCheck("Rupture",lib.GetAura({"Rupture"})-2)
			end
			return nil
		end,
	}
	
	cfg.plist=cfg.plistdps
	cfg.mode = "dps"
--[[	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end]]
	
--	cfg.spells_aoe={"Swipe"}
--	cfg.spells_single={"Shred","Mangle","Rip"}

	lib.rangecheck=function()
		if lib.inrange("SS") then
			lib.bdcolor(Heddmain.bd,nil)
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end
	
	
	return true
end

lib.classevents["ROGUE"] = function()
	lib.AddAuras("Vanish",{1784,11327},"buff","player") -- Vanish
	lib.AddSpell("Vanish",{1856}) -- Vanish
	cfg.case["Vanish"] = function()
		if lib.HasAuras("Vanish") then
			return nil
		end
		return lib.SimpleCDCheck("Vanish")
	end

--[[	function Heddclassevents.UNIT_POWER_FREQUENT(unit,powerType)
		if unit=="player" and powerType==cfg.Power.type then

			lib.UpdateAllSpells("power")
		end
	end]]
	
--[[	function Heddclassevents:UNIT_COMBO_POINTS()
		lib.ComboUpdate()
	end]]
	lib.CD = function()
		lib.CDadd("Vanish")
		lib.CDadd("Preparation")
		lib.CDadd("AR")
		lib.CDadd("KS")
	end

	cfg.onpower=true
	
end