-- /run for i=1,40 do local name, _, icon, count, type, duration, exp, unitCaster, isStealable, _, spellId=UnitBuff("player",i); if name then type=debuffType or "other"; print(unitCaster.." "..type.." "..count.." "..name.." = "..spellId) end end
-- /run for i=1,40 do local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId=UnitDebuff("target",i); if name then print(name.."="..spellId) end end
-- /run for i=1,40 do local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId=UnitBuff("pet",i); if name then print(count.." "..name.."("..expirationTime..")".." = "..spellId) end end
-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.SetTrackDOT = function(aura,maxdot,spell,func)
	if cfg.auras[aura] then
		cfg.TrackDOT.maxtick=maxdot or cfg.TrackDOT.maxtick
		cfg.TrackDOT.spell=aura
		cfg.TrackDOT.id=cfg.auras[aura].id
		if spell and cfg.spells[spell] then
			Heddmain.DOT.texture:SetTexture(cfg.spells[spell].icon)
		else
			Heddmain.DOT.texture:SetTexture(cfg.auras[aura].icon)
		end
		if func then
			cfg.TrackDOT.func=func
		else
			cfg.TrackDOT.func=nil
		end
		Heddmain.DOT:Show()
		Heddmain.DOT:SetScript("OnUpdate", lib.OnUpdateTrackDOT)
		lib.UpdateTrackDOT()
		lib.UpdateTrackDOTFrame()
	else
		Heddmain.DOT:Hide()
		Heddmain.DOT:SetScript("OnUpdate", nil)
	end
end

lib.AddTrackDOT = function(guid)
	cfg.TrackDOT.targets[guid]=GetTime()
	lib.UpdateTrackDOT()
end

lib.DelTrackDOT = function(guid)
	cfg.TrackDOT.targets[guid]=nil
	lib.UpdateTrackDOT()
end

local pDOTS
lib.UpdateTrackDOT = function()
	pDOTS=cfg.TrackDOT.num
	cfg.TrackDOT.num=0
	for guid,value in pairs(cfg.TrackDOT.targets) do
		if GetTime()>(cfg.TrackDOT.targets[guid]+cfg.TrackDOT.maxtick) then
			cfg.TrackDOT.targets[guid]=nil
		else
			cfg.TrackDOT.num=cfg.TrackDOT.num+1
		end
	end
	if pDOTS~=cfg.TrackDOT.num then cfg.TrackDOT.Update=true end
end

lib.UpdateTrackDOTFrame = function()
	if HeddDB.DOT=="hide" then
		Heddmain.DOT:Hide()
		return
	else
		Heddmain.DOT:Show()
	end
	if cfg.TrackDOT.func then
		cfg.TrackDOT.func()
		return
	end
	if cfg.TrackDOT.num>0 then 
		lib.ShowTrackDOT()
	else
		lib.HideTrackDOT()
	end
end

lib.OnUpdateTrackDOT = function (self, elapsed)
	elapsed = elapsed or 0
	cfg.TrackDOT.lastUpdate = cfg.TrackDOT.lastUpdate + elapsed
	if cfg.TrackDOT.lastUpdate > cfg.TrackDOT.maxtick then --cfg.freq
		lib.UpdateTrackDOT()
	end
	if cfg.TrackDOT.Update then
		lib.UpdateTrackDOTFrame()
		cfg.TrackDOT.lastUpdate = 0
		cfg.TrackDOT.Update=false
		cfg.Update=true
	end	
end

lib.ShowTrackDOT=function()
	Heddmain.DOT.texture:Show()
	Heddmain.DOT.text:SetText(cfg.TrackDOT.num)
end

lib.HideTrackDOT=function()
	Heddmain.DOT.texture:Hide()
	Heddmain.DOT.text:SetText("")
	Heddmain.DOT.cooldown:Hide()
end

lib.SetTrackAura = function(spell,maxbuffs)
	if cfg.auras[spell] then
		cfg.TrackAura.spell=spell
		cfg.TrackAura.unit=cfg.auras[spell].unit
		cfg.TrackAura.max=maxbuffs or 0
		Heddmain.Aura.texture:SetTexture(cfg.auras[spell].icon)
		lib.UpdateAuraFrame()
	else
		Heddmain.Aura:Hide()
	end
end

local pBUFF
lib.UpdateTrackAura=function(guid,num)
	pBUFF=cfg.TrackAura.targets[guid]
	if num then
		cfg.TrackAura.targets[guid]=num
	else
		cfg.TrackAura.targets[guid]=nil
	end
	if pBUFF~=cfg.TrackAura.targets[guid] or cfg.auras[cfg.TrackAura.spell].reapply then
		lib.UpdateAuraFrame()
	end
end

lib.GetTrackAura=function()
	if cfg.TrackAura.spell and lib.GetAura({cfg.TrackAura.spell})>0 then
		return cfg.TrackAura.targets[cfg.GUID[cfg.TrackAura.unit]] or -1
	end
	return -1
end

local guid
lib.UpdateAuraFrame=function()
	if not cfg.TrackAura.spell then
		Heddmain.Aura:Hide()
		return
	end
	
	if HeddDB.Aura=="hide" then
		Heddmain.Aura:Hide()
		return
	else
		Heddmain.Aura:Show()
	end

	if cfg.GUID[cfg.TrackAura.unit] and cfg.TrackAura.targets[cfg.GUID[cfg.TrackAura.unit]] and lib.GetAura({cfg.TrackAura.spell})>0 then
		Heddmain.Aura:Show()
		CooldownFrame_SetTimer(Heddmain.Aura.cooldown,cfg.auras[cfg.TrackAura.spell].expire-cfg.auras[cfg.TrackAura.spell].duration, cfg.auras[cfg.TrackAura.spell].duration,1)
		if cfg.TrackAura.max>0 then
			Heddmain.Aura.text:SetText(cfg.TrackAura.targets[cfg.GUID[cfg.TrackAura.unit]].."/"..cfg.TrackAura.max)
		else
			Heddmain.Aura.text:SetText(" ")
		end
	else
		Heddmain.Aura:Hide()
	end
end

lib.AddAura = function(spell,id,atype,unit,caster) --,onchange
	if not lib.Hedd_GSI(id) then 
	print("Warning!!! Aura \""..spell.."\" with id="..id.." is not in game!")
	return
	end
	atype=atype or "buff"
	if atype=="buff" then
		unit=unit or "player"
	else
		unit=unit or "target"
	end
	caster=caster or "player"
	
	cfg.watchunits[unit]=true
	cfg.auras[spell] ={}
	cfg.auras[spell].id=id
	cfg.auras[spell].name = lib.Hedd_GSI(id)
	cfg.auras[spell].spell = spell
	cfg.id2aura[cfg.auras[spell].id]=cfg.id2aura[cfg.auras[spell].id] or {}
	table.insert(cfg.id2aura[cfg.auras[spell].id],#cfg.id2aura[cfg.auras[spell].id]+1,spell)
	cfg.auras[spell].duration=0
	--cfg.auras[spell].pduration=0
	cfg.auras[spell].expire=0
	--cfg.auras[spell].pexpire=0
	cfg.auras[spell].stacks=0
	cfg.auras[spell].type=atype
	cfg.auras[spell].unit=unit
	cfg.auras[spell].caster=caster
	cfg.auras[spell].present=0
	cfg.auras[spell].lasttime=0
	cfg.auras[spell].pstacks=0
	cfg.auras[spell].icon=(select(3,GetSpellInfo(id)))
	cfg.auras[spell].apply=false
	cfg.auras[spell].reapply=false
	cfg.auras[spell].fade=false
	if not cfg.auras_found[unit] then
		cfg.auras_found[unit]={}
	end
	cfg.auras_found[unit][spell]=false
	--print("Adding "..cfg.auras[spell].name)
	lib.UpdateAura(spell)
end

lib.SetAuraFunction = function(spell,event,func)
	if cfg.auras[spell] then
		if event=="OnApply" then
			cfg.auras[spell].OnApply=cfg.auras[spell].OnApply or {}
			table.insert(cfg.auras[spell].OnApply,#cfg.auras[spell].OnApply+1,func)
			
			cfg.auras[spell].OnReApply=cfg.auras[spell].OnReApply or {}
			table.insert(cfg.auras[spell].OnReApply,#cfg.auras[spell].OnReApply+1,func)
		end
		if event=="OnReApply" then
			cfg.auras[spell].OnReApply=cfg.auras[spell].OnReApply or {}
			table.insert(cfg.auras[spell].OnReApply,#cfg.auras[spell].OnReApply+1,func)
		end
		if event=="OnFade" then
			cfg.auras[spell].OnFade=cfg.auras[spell].OnFade or {}
			table.insert(cfg.auras[spell].OnFade,#cfg.auras[spell].OnFade+1,func)
		end
		if event=="OnStacks" then
			cfg.auras[spell].OnStacks=cfg.auras[spell].OnStacks or {}
			table.insert(cfg.auras[spell].OnStacks,#cfg.auras[spell].OnStacks+1,func)
		end
	end
end

lib.AddAuras = function(spell,ids,atype,unit)
	if atype=="buff" then
		unit=unit or "player"
	else
		atype="debuff"
		unit=unit or "target"
	end

	for index,id in ipairs(ids) do
		lib.AddAura(spell..index,id,atype,unit,"any")
		if cfg.auras[spell..index] then
			cfg.auras[spell..index].row=#ids
		end
	end
end


auras_old={}
lib.UpdateAuraAll = function(unit)
	local spell
	if cfg.auras_found[unit] then
		for spell,_ in pairs(cfg.auras_found[unit]) do
			cfg.auras_found[unit][spell]=false
			--print(spell.." searching")
		end
	end
	
	if cfg.dispell_player_spell and unit=="player" then
		cfg.dispell_player=false
	end
	
	if cfg.dispell_target_spell and unit=="target" then
		cfg.dispell_target=false
	end
		
	--buffs
	for i=1,40 do
		aname, _, _, acount, adispelType, aduration, aexpirationTime, aunitCaster, _, _, aid = UnitAura(unit,i,"HELPFUL")
		if aid then
			adispelType=adispelType or "Other"
			if hedlib.enrage[aid] then adispelType="Enrage" end
			if unit=="target" and cfg.dispell_target_spell and cfg.dispell_target_type[adispelType] then
				cfg.dispell_target=true
			end
			if cfg.id2aura[aid] then
				for _,spell in pairs(cfg.id2aura[aid]) do
					if (cfg.auras[spell].caster==aunitCaster) or cfg.auras[spell].caster=="any" then
						hedlib.shallowCopy(cfg.auras[spell],auras_old)
						if cfg.auras_found[unit] then cfg.auras_found[unit][spell]=true end
						cfg.auras[spell].duration=aduration
						cfg.auras[spell].expire=aexpirationTime
						cfg.auras[spell].stacks=acount or 1
						cfg.auras[spell].present=1
						if cfg.auras[spell].stacks==0 then cfg.auras[spell].stacks=1 end
						lib.IsAuraChanged(cfg.auras[spell],auras_old)
					end
				end
			end
		end
	end
	
	--debuffs
	for i=1,40 do
		aname, _, _, acount, adispelType, aduration, aexpirationTime, aunitCaster, _, _, aid = UnitAura(unit,i,"HARMFUL")
		if aid then
			adispelType=adispelType or "Other"
			if hedlib.enrage[aid] then adispelType="Enrage" end
			if unit=="player" and cfg.dispell_player_spell and cfg.dispell_player_type[adispelType] then
				cfg.dispell_player=true
			end
			if cfg.id2aura[aid] then
				for _,spell in pairs(cfg.id2aura[aid]) do
					if (cfg.auras[spell].caster==aunitCaster) or cfg.auras[spell].caster=="any" then
						hedlib.shallowCopy(cfg.auras[spell],auras_old)
						if cfg.auras_found[unit] then cfg.auras_found[unit][spell]=true end
						cfg.auras[spell].duration=aduration
						cfg.auras[spell].expire=aexpirationTime
						cfg.auras[spell].stacks=acount or 1
						cfg.auras[spell].present=1
						if cfg.auras[spell].stacks==0 then cfg.auras[spell].stacks=1 end
						lib.IsAuraChanged(cfg.auras[spell],auras_old)
					end
				end
			end
		end
	end
	
	if cfg.auras_found[unit] then
		for spell,_ in pairs(cfg.auras_found[unit]) do
			if cfg.auras_found[unit][spell]==false then
				hedlib.shallowCopy(cfg.auras[spell],auras_old)
				cfg.auras[spell].duration=0
				cfg.auras[spell].expire=0
				cfg.auras[spell].stacks=0
				cfg.auras[spell].present=0
				lib.IsAuraChanged(cfg.auras[spell],auras_old)
			end
		end
	end
	
	if cfg.dispell_target or cfg.dispell_player then cfg.Update=true end
end

local aura_msg=nil
lib.IsAuraChanged = function(aura,aura_old)
	if not hedlib.ArrayNotChanged(aura,aura_old) then
		aura_msg="Updating "..aura.spell
		if aura_old.duration>0 and aura.duration==0 then
			aura.pstacks=aura_old.stacks
			aura.lasttime=GetTime()
			aura.apply=false
			aura.reapply=false
			aura.fade=true
			aura_msg=aura_msg.." Fading"
			if aura.OnFade then
				for _,func in pairs(aura.OnFade) do
					func()
				end
			end
		elseif aura_old.duration==0 and aura.duration>0 then
			aura.apply=true
			aura.reapply=false
			aura.fade=false
			aura_msg=aura_msg.." Appling"
			if aura.OnApply then
				for _,func in pairs(aura.OnApply) do
					func()
				end
			end
		elseif aura_old.expire<aura.expire or aura_old.stacks~=aura.stacks then
			aura.apply=false
			aura.reapply=true
			aura.fade=false
			aura_msg=aura_msg.." Reappling"
			if aura.OnReApply then
				for _,func in pairs(aura.OnReApply) do
					func()
				end
			end
			if aura_old.stacks~=aura.stacks and aura.OnStacks then
				for _,func in pairs(aura.OnStacks) do
					func()
				end
			end
		end
		
		if cfg.debugauras then print(aura_msg) end 
		cfg.Update=true
		return true
	else
		return false
	end
end


lib.PrintBuff = function(unit, bufftype)
	bufftype=bufftype or "Magic"
	for i=1,40 do
		local name, _, icon, count, b_type, duration, b_exp, caster, stealable, _, spellId=UnitBuff(unit,i)
		if name then
			if count==0 then count=1 end
			b_type=b_type or "Other"
			if hedlib.enrage[spellId] then b_type="Enrage" end
			if b_type==bufftype or bufftype=="all" then
				tmp=name
				tmp=tmp.." ("..spellId..") "
				tmp=tmp..b_type
				tmp=tmp.." count="..count
				tmp=tmp.." left="..(duration==0 and 9999 or math.max(0,b_exp-GetTime()))
				tmp=tmp.." duration="..duration
				tmp=tmp.." expire="..b_exp
				tmp=tmp.." caster="..caster
				print(tmp)
			end
		end
	end
end

--Curse
--Disease
--Magic
--Poison
--Enrage
local buffs=nil
lib.CheckBuff = function(unit, bufftype)
	bufftype=bufftype or {"Magic"}
	if not buffs then
		buffs={}
		for _,id in ipairs(bufftype) do
			buffs[id]=true
		end
	end
	for i=1,40 do
		local name, _, _, _, b_type, _, _, _, _, _, spellId=UnitBuff(unit,i)
		if name then
			b_type=b_type or "Other"
			if hedlib.enrage[spellId] then b_type="Enrage" end
			if buffs[b_type] then
				return true
			end
		end
	end
	return nil
end

local debuffs=nil
lib.CheckDebuff = function(unit, bufftype)
	bufftype=bufftype or {"Magic"}
	if not debuffs then
		debuffs={}
		for _,id in ipairs(bufftype) do
			debuffs[id]=true
		end
	end
	for i=1,40 do
		local name, _, _, _, b_type, _, _, _, _, _, spellId=UnitDebuff(unit,i)
		if name then
			b_type=b_type or "Other"
			if hedlib.enrage[spellId] then b_type="Enrage" end
			if debuffs[b_type] then
				return true
			end
		end
	end
	return nil
end


lib.UpdateAura = function(spell)
	if cfg.auras[spell] then
		hedlib.shallowCopy(cfg.auras[spell],auras_old)
		if cfg.auras[spell].type=="debuff" then
			atype="HARMFUL"
		else
			atype="HELPFUL"
		end
		if cfg.auras[spell].caster=="player" then
			atype=atype.." PLAYER"
		end
		found=nil
		for i=1,40 do
			aname, _, _, acount, _, aduration, aexpirationTime, aunitCaster, _, _, aid = UnitAura(cfg.auras[spell].unit,i,atype)
			if cfg.auras[spell].id==aid then
				cfg.auras[spell].duration=aduration
				cfg.auras[spell].expire=aexpirationTime
				cfg.auras[spell].stacks=acount or 1
				cfg.auras[spell].present=1
				if cfg.auras[spell].stacks==0 then cfg.auras[spell].stacks=1 end
				found=true
				break
			end
		end
		if not found then
			cfg.auras[spell].duration=0
			cfg.auras[spell].expire=0
			cfg.auras[spell].stacks=0
			cfg.auras[spell].present=0
		end

		lib.IsAuraChanged(cfg.auras[spell],auras_old)
	end
	return nil
end

lib.AuraInTime = function (spell , mint, maxt)
	if not cfg.auras[spell] then return nil end
	if cfg.auras[spell].lasttime >= mint and cfg.auras[spell].lasttime <=maxt then
		return true
	else
		return nil
	end
end

lib.GetAuraLastTime = function (spell)
	if cfg.auras[spell] then
		return cfg.auras[spell].lasttime
	end
	return 0
end

lib.GetAuraLastTimeStacks = function (spell)
	if cfg.auras[spell] then
		return cfg.auras[spell].pstacks
	end
	return 0
end

lib.GetAuraId = function (spell)
	if cfg.auras[spell] then
		return cfg.auras[spell].id
	end
	return "noaura"
end

local tl_aura
lib.GetAura = function(auras)
	tl_aura = 0
	for _,n_aura in ipairs(auras) do
		if cfg.auras[n_aura] and cfg.auras[n_aura].present==1 then
			tl_aura = (cfg.auras[n_aura].duration==0 and 9999 or math.max(0,cfg.auras[n_aura].expire-GetTime()))
			if tl_aura>0 then 
				return tl_aura
			end
		end
	end
	return 0
end

local i_aura
--[[lib.GetAuras = function(aura)
	tl_aura = 0
	i_aura=1
	notfound_aura=true
	while notfound_aura do
		n_aura=aura..i_aura
		if cfg.auras[n_aura] then
			if cfg.auras[n_aura].present==1 then
				tl_aura = (cfg.auras[n_aura].duration==0 and 9999 or math.max(0,cfg.auras[n_aura].expire-GetTime())
				if tl_aura>0 then 
					notfound_aura=false
					return tl_aura
				end
			end
			i_aura=i_aura+1
		else
			notfound_aura=false
			return 0
		end
	end
	return 0
end]]

local auras={}
lib.GetAuras = function(aura)
	auras={}
	i_aura=1
	notfound_aura=true
	while notfound_aura do
		n_aura=aura..i_aura
		if cfg.auras[n_aura] then
			table.insert(auras,n_aura)
		else
			notfound_aura=false
		end
		i_aura=i_aura+1
	end
	return lib.GetAura(auras)
	--return 0
end

lib.HasAuras = function(aura)
	i_aura=1
	notfound_aura=true
	while notfound_aura do
		n_aura=aura..i_aura
		if cfg.auras[n_aura] then
			if cfg.auras[n_aura].present==1 then 
				return true
			end
			i_aura=i_aura+1
		else
			notfound_aura=nil
		end
	end
	return nil
end

lib.IsAura = function(auras)
	if lib.GetAura(auras)>0 then
		return 1
	else
		return 0
	end
end

lib.GetShortestAura = function(auras)
	tl_aura=99999
	for _,n_aura in ipairs(auras) do
		if cfg.auras[n_aura] then
			tl_caura=cfg.auras[n_aura].expire-GetTime()
			tl_caura = (tl_caura>=0) and tl_caura or 0
			if tl_caura<tl_aura then tl_aura=tl_caura end
		end
	end
	if tl_aura==99999 then return 0 end
	return tl_aura
end

lib.GetLargestAura = function(auras)
	tl_aura=0
	for _,n_aura in ipairs(auras) do
		if cfg.auras[n_aura] then
			tl_caura=cfg.auras[n_aura].expire-GetTime()
			tl_caura = (tl_caura>=0) and tl_caura or 0
			if tl_caura>tl_aura then tl_aura=tl_caura end
		end
	end
	return tl_aura
end

lib.GetLargestNumber = function(numbers)
	bignumber=0
	for _,n_num in ipairs(numbers) do
		if n_num>bignumber then bignumber=n_num end
	end
	return bignumber
end

local tl_aura
lib.GetAuraNum = function(aura)
	if cfg.auras[aura] then
		tl_aura=math.max(0,cfg.auras[aura].expire-GetTime())
		if cfg.auras[aura].present==1 and tl_aura==0 then tl_aura=99999 end
		if tl_aura>0 then return (cfg.auras[aura].stacks) end
	end
	return 0
end

lib.UpdateWeaponBuffs = function()
	pMain, pOff = cfg.Weapons.Main, cfg.Weapons.Off
	cfg.Weapons.Main, _, _, cfg.Weapons.Off = GetWeaponEnchantInfo()
	if pMain~=cfg.Weapons.Main or pOff~=cfg.Weapons.Off then return true end
	return false
end

lib.AddDispellTarget = function(spell,spellids,types)
	lib.AddSpell(spell,spellids)
	if cfg.spells[spell] then
		cfg.watchunits["target"]=true
		for _,n_type in ipairs(types) do
			cfg.dispell_target_type[n_type]=true
		end
		cfg.dispell_target_spell=spell
		cfg.case[spell] = function()
			if cfg.dispell_target then
				return lib.SimpleCDCheck(spell)
			end
			return nil
		end
	end
end

lib.AddDispellPlayer = function(spell,spellids,types)
	lib.AddSpell(spell,spellids)
	if cfg.spells[spell] then
		cfg.watchunits["player"]=true
		for _,n_type in ipairs(types) do
			cfg.dispell_player_type[n_type]=true
		end
		cfg.dispell_player_spell=spell
		cfg.case[spell] = function()
			if cfg.dispell_player then
				return lib.SimpleCDCheck(spell)
			end
			return nil
		end
	end
end